-- Author      : Kressilac /Duskwood - Bathral@BlackhandEU
-- UI elements borrowed from Shadow Timer and extended for better use.
-- Create Date : 21/05/2013


local _ -- workaround to prevent leaking globals

--ShadowPriestDoTTimerFrame_Default_X = 0;
--ShadowPriestDoTTimerFrame_Default_Y = 0;
--ShadowPriestDoTTimerFrame_Default_Size = 100;
--ShadowPriestDoTTimerFrame_Default_Scale = 1;

local MyAddon_UpdateInterval = 0.05; -- How often the OnUpdate code will run (in seconds)
local TimeSinceLastUpdate = 0;

local WarningTime = 600; -- WarningTime (in milliseconds)
local buffscorecurrent = 0;

--Used to proove that a Priest is being played
local Priest = false;
local ShadowSpecc = false;

--Used to keep track of the DoTs on a Mob.
local moblist = {}
local isincombat = false;
local currentmob = nil;
local maxmoblist = 10;


--Save the previous ShadowOrbs number
local PrevShadowOrbsCount = nil;

--Buff modifier table for SaI with different Shadow orbs
local PrevShadowOrbs = {
	"33 %",
	"66 %",
	"100 %",
}

--Used to prioritize DP texture over Shadoworbs
local Texture3used = false;

--Used to share Texture5 for Mindblast and SW:D
local Texture5used = false;

--Used to indivate UVLS is active
local UVLS_active = false;

--Used to determine if 2 piece T15 Set bonus is equipped
local set2t15 = false

--Duration of DoTs for 2t15set bonus proc check
local VTduration = 0;
local SWPduration = 0;


----------------------------------------------
local WordPainID = 589;
local nameWordPain, rankWordPain, IconWordPain = GetSpellInfo(WordPainID);
--"Interface\\ICONS\\Spell_Shadow_ShadowWordPain.blp";
----------------------------------------------
local VTID = 34914
local nameVT, rankVT, IconVT, costVT, isFunnelVT, powerTypeVT, castTimeVT, minRangeVT, maxRangeVT = GetSpellInfo(VTID)	
--"Interface\\ICONS\\Spell_Holy_Stoicism.blp";
----------------------------------------------
local PlagueID = 2944
local namePlague, rankPlague, IconPlague = GetSpellInfo(PlagueID);
--"Interface\\ICONS\\Spell_Shadow_DevouringPlague.blp";
----------------------------------------------
local WordDeathID = 32379;
local nameWordDeath, rankWordDeath, IconWordDeath = GetSpellInfo(WordDeathID);	--"Shadow Word: Death"
----------------------------------------------
local SPELL_POWER_SHADOW_ORBS  = SPELL_POWER_SHADOW_ORBS 
local IconShadowOrbs = "Interface\\ICONS\\spell_priest_shadoworbs.blp"
----------------------------------------------
local MindBlastID = 8092;
local nameMindBlast, rankMindBlast, IconMindBlast = GetSpellInfo(MindBlastID);
----------------------------------------------
local EmbraceID = 15286;
local nameEmbrace, rankEmbrace, IconEmbrace = GetSpellInfo(EmbraceID);	--"Vampiric Embrace"
--local IconEmbrace = "Interface\\ICONS\\spell_shadow_unsummonbuilding.blp"
----------------------------------------------
local PowerInfusionID = 10060;
local namePowerInfusion, rankPowerInfusion, IconPowerInfusion = GetSpellInfo(PowerInfusionID);
----------------------------------------------
local SurgeOfDarknessID = 87160;
local nameSurgeOfDarkness, rankSurgeOfDarkness, IconSurgeOfDarkness = GetSpellInfo(SurgeOfDarknessID);
----------------------------------------------
local SolaceInsanityID = 129249;
local nameSolaceInsanity, rankSolaceInsanity, IconSolaceInsanity = GetSpellInfo(SolaceInsanityID);
---------------------------------------------- 
local DivineInsightID = 124430;
local nameDivIn, rankDivIn, IconDivIn = GetSpellInfo(DivineInsightID);
----------------------------------------------
local MindbenderID = 123040;
local nameMindbender, rankMindbender, IconMindbender = GetSpellInfo(MindbenderID);
----------------------------------------------
local Shadowy_ApparitionsID = 87532;
local nameShadowy_Apparitions, rankShadowy_Apparitions, IconShadowy_Apparitions = GetSpellInfo(Shadowy_ApparitionsID)
----------------------------------------------
local UVLS_itemID = 94524;
local _, _, _, _, _, _, _, _, _, IconUVLS, _ = GetItemInfo(UVLS_itemID);
----------------------------------------------


function PriestCheck()
	local playerClass, englishClass = UnitClass("player");
	return englishClass;
end

--function round(num) 
--    if num >= 0 then return math.floor(num+.5) 
--    else return math.ceil(num-.5) end
--end


function Detect2T15()
    set2t15 = false;
    local t15items = 0;
    local t15set = {
        96674,96675,96676,96677,96678,
        95300,95301,95302,95303,95304,
        95930,95931,95932,95933,95934,
    };
    for i,v in ipairs(t15set) do
        if IsEquippedItem(v) then
            t15items = t15items + 1;
        end
    end
    if t15items >= 2 then 
    	set2t15 = true;
    end
    --DEFAULT_CHAT_FRAME:AddMessage("set2T15:", set2t15);
end

function ShadowPriestDoTTimerFrame_OnLoad(self)
	ShadowPriestDoTTimerFrame:RegisterEvent("PLAYER_LOGOUT");
	ShadowPriestDoTTimerFrame:RegisterEvent("ADDON_LOADED");
	ShadowPriestDoTTimerFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	ShadowPriestDoTTimerFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	ShadowPriestDoTTimerFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
	ShadowPriestDoTTimerFrame:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	
	local Class = PriestCheck();
	local currentSpec = GetSpecialization();
	if (Class ~= "PRIEST") then
		--not a Priest
		Priest = false;
		DEFAULT_CHAT_FRAME:AddMessage("---Shadow Priest DoT Timer Not Loaded---");
	else -- Is a Priest
		Priest = true;
		--with Shadow Spec
		if (currentSpec == 3) then
			ShadowSpecc = true;
			DEFAULT_CHAT_FRAME:AddMessage("---Shadow Priest DoT Timer Loaded---");
			Detect2T15();
		--with another specc
		else 
			local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None";
			ShadowSpecc = false;
			DEFAULT_CHAT_FRAME:AddMessage("You are now playing in " .. currentSpecName .. " Specc!");
			DEFAULT_CHAT_FRAME:AddMessage("---Shadow Priest DoT Timer turned off---");
		end
	end
	
	Texture1:SetTexture(IconVT);
	Texture2:SetTexture(IconWordPain);
	Texture3:SetTexture(IconPlague);
	Texture5:SetTexture(IconMindBlast);
	Texture6:SetTexture(IconPowerInfusion);
	Texture7:SetTexture(IconSurgeOfDarkness);
	Texture8:SetTexture(IconEmbrace);
	
	Texture1:Hide();
	Texture2:Hide();
	Texture3:Hide();
	Texture4:Hide();
	Texture5:Hide();
	Texture6:Hide();
	Texture7:Hide();
	Texture8:Hide();

	TEXT1:Hide();
	TEXT2:Hide();	
	TEXT3:Hide();
	TEXT4:Hide();
	TEXT5:Hide();
	TEXT6:Hide();
	TEXT7:Hide();
	TEXT8:Hide();
	
	TEXT1Above:Show();
	TEXT2Above:Show();
	TEXT3Above:Show();
	TEXT3Above2:Hide();
	TEXT5Above:Hide();
	TEXT6Above:Hide();
	TEXT7Above:Hide();
	TEXT8Above:Hide();
	
	TimeSinceLastUpdate = 0;

	ShadowPriestDoTTimerFrame:RegisterForDrag("LeftButton", "RightButton");
	ShadowPriestDoTTimerFrame:EnableMouse(false);
end

function HideAll()
	Texture1:Hide();
	Texture2:Hide();
	Texture3:Hide();
	Texture4:Hide();
	Texture5:Hide();
	Texture6:Hide();
	Texture7:Hide();
	Texture8:Hide();

	TEXT1:Hide();
	TEXT2:Hide();	
	TEXT3:Hide();
	TEXT4:Hide();
	TEXT5:Hide();
	TEXT6:Hide();
	TEXT7:Hide();
	TEXT8:Hide();
	
	TEXT1Above:Hide();
	TEXT2Above:Hide();
	TEXT3Above:Hide();
	TEXT3Above2:Hide();
	TEXT5Above:Hide();
	TEXT6Above:Hide();
	TEXT7Above:Hide();
	TEXT8Above:Hide();
	
	buffscorecurrent = 0;
end	

function ShadowPriestDoTTimerFrame_OnUpdate(elapsed)
	-- check if Class is a Priest
	if (Priest == true) then
		--Specc is Shadow
		if (GetSpecialization() == 3) then
			ShadowSpecc = true;
			TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	
			while (TimeSinceLastUpdate > MyAddon_UpdateInterval) do
				CheckCurrentTargetDeBuffs();
				CheckPlayerBuffs();
		
				if (buffscorecurrent > 0 and isincombat == true and HideBuffscore == 0) then
					if (UVLS_active == true) then
						TEXT4:SetText(string.format("%s", "UVLS"));
						TEXT4:SetVertexColor(0.9, 0.2, 0.2);	--red
					else
						TEXT4:SetText(string.format("%d", buffscorecurrent));
						TEXT4:SetVertexColor(1.0, 0.9, 0.1);	--yellow
					end
					TEXT4:Show();
				else
					TEXT4:Hide();
				end
				TimeSinceLastUpdate = TimeSinceLastUpdate - MyAddon_UpdateInterval;
			end
		--Check if the specialization has changed to Holy or Disc
		else
			ShadowSpecc = false;
			Priest = false;
			HideAll();
		end
	else
		--Check if the specialization has changed to shadow and Class is Priest
		if (GetSpecialization() == 3 and PriestCheck() == "PRIEST") then
			ShadowSpecc = true;
			Priest = true;
		else
			HideAll();
			--do nothing;
		end
	end
end

function ShadowPriestDoTTimerFrame_OnEvent(self, event, ...)
	local arg1 = ...;

	if (event == "UNIT_SPELLCAST_SUCCEEDED") then
		local unit, _, _, _, spellid = ...;
		if (unit == "player") then
			if (spellid == VTID) then
				if (HideNumberAboveVT == 0) then
					if (UVLS_active == true) then
						TEXT1Above:SetText(string.format("%s", "UVLS"));
					else
						TEXT1Above:SetText(string.format("%d", buffscorecurrent));
					end
					TEXT1Above:Show();
				end
				
				FindOrCreateCurrentMob();
				if (currentmob) then
					currentmob[2] = buffscorecurrent;
					currentmob[4] = GetTime();
					if (UVLS_active == true) then
						currentmob[5] = true;
						currentmob[7] = GetTime();
						--DEFAULT_CHAT_FRAME:AddMessage("SPDT UVLS on VT: " .. currentmob[7]);
					else
						currentmob[5] = false;
						currentmob[7] = 0;
					end					
				end
			elseif (spellid == WordPainID) then
				if (HideNumberAboveSWP == 0) then
					if (UVLS_active == true) then
						TEXT2Above:SetText(string.format("%s", "UVLS"));
					else
						TEXT2Above:SetText(string.format("%d", buffscorecurrent));
					end
					TEXT2Above:Show();
				end
				
				FindOrCreateCurrentMob();
				if (currentmob) then
					currentmob[3] = buffscorecurrent;
					currentmob[4] = GetTime();
					if (UVLS_active == true) then
						currentmob[6] = true;
						currentmob[8] = GetTime();
						--DEFAULT_CHAT_FRAME:AddMessage("SPDT UVLS on: " .. currentmob[8]);
					else
						currentmob[6] = false;
						currentmob[8] = 0;
					end	
				end
--			elseif (spellid == Shadowy_ApparitionsID and set2t15 == true) then
--				DEFAULT_CHAT_FRAME:AddMessage("Shadowy app hits with 2pt15 ");
--				local finished = false;
--				local count = 0;
--				while not finished do
--					count = count+1				
--					local bn,brank,bicon,bcount,bType,bduration,bexpirationTime,bisMine,bisStealable,bshouldConsolidate,bspellId =  UnitDebuff("target", count, 0);
--					if not bn then
--						finished = true
--					else
--					--DEFAULT_CHAT_FRAME:AddMessage("testing debuff");
--						if bisMine == "player" then
--						--DEFAULT_CHAT_FRAME:AddMessage("ismine debuff");
--							if bn == nameVT then
--								if (bduration > VTduration) then 
--									VTduration = bduration;
--									if (HideNumberAboveVT == 0) then
--										if (UVLS_active == true) then
--											TEXT1Above:SetText(string.format("%s", "UVLS"));
--										else
--											TEXT1Above:SetText(string.format("%d", buffscorecurrent));
--										end
--										TEXT1Above:Show();
--									end
--					
--									FindOrCreateCurrentMob();
--									if (currentmob) then
--										currentmob[2] = buffscorecurrent;
--										currentmob[4] = GetTime();
--										if (UVLS_active == true) then
--											currentmob[5] = true;
--											currentmob[7] = GetTime();
--											--DEFAULT_CHAT_FRAME:AddMessage("SPDT UVLS on VT: " .. currentmob[7]);
--										else
--											currentmob[5] = false;
--											currentmob[7] = 0;
--										end					
--									end
--								end	
--							end
--							if bn == nameWordPain then 
--								if (bduration > SWPduration) then
--									SWPduration = bduration;
--									if (HideNumberAboveSWP == 0) then
--										if (UVLS_active == true) then
--											TEXT2Above:SetText(string.format("%s", "UVLS"));
--										else
--											TEXT2Above:SetText(string.format("%d", buffscorecurrent));
--										end
--										TEXT2Above:Show();
--									end
--									
--									FindOrCreateCurrentMob();
--									if (currentmob) then
--										currentmob[3] = buffscorecurrent;
--										currentmob[4] = GetTime();
--										if (UVLS_active == true) then
--											currentmob[6] = true;
--											currentmob[8] = GetTime();
--											--DEFAULT_CHAT_FRAME:AddMessage("SPDT UVLS on: " .. currentmob[8]);
--										else
--											currentmob[6] = false;
--											currentmob[8] = 0;
--										end	
--									end
--								end
--							end
--						end
--					end
--				end
			elseif (spellid == MindBlastID) then
				--DEFAULT_CHAT_FRAME:AddMessage("Mindblast event: ");	
				local SPELL_POWER_SHADOW_ORBS  = SPELL_POWER_SHADOW_ORBS;
				local NumOfOrbs = UnitPower('player', SPELL_POWER_SHADOW_ORBS);
				PrevShadowOrbsCount = PrevShadowOrbs[NumOfOrbs];
				--DEFAULT_CHAT_FRAME:AddMessage("Prev Shadow Orbs: " .. PrevShadowOrbsCount);
			elseif (spellid == WordDeathID) then
				--DEFAULT_CHAT_FRAME:AddMessage("SWD event: ");	
				local SPELL_POWER_SHADOW_ORBS  = SPELL_POWER_SHADOW_ORBS;
				local NumOfOrbs = UnitPower('player', SPELL_POWER_SHADOW_ORBS);
				PrevShadowOrbsCount = PrevShadowOrbs[NumOfOrbs];
				--DEFAULT_CHAT_FRAME:AddMessage("Prev Shadow Orbs: " .. PrevShadowOrbsCount);
			end
		end
	elseif (event == "PLAYER_EQUIPMENT_CHANGED") then
		Detect2T15();
	elseif (event == "ADDON_LOADED" and arg1 == "ShadowPriestDoTTimer") then
		if (not ShadowPriestDoTTimerFrameScaleFrame) then
			ShadowPriestDoTTimerFrameScaleFrame = 1.0
		end
		ShadowPriestDoTTimerFrame:SetScale(ShadowPriestDoTTimerFrameScaleFrame);
		SetCooldownOffsets();
	elseif (event == "PLAYER_LOGOUT") then
		ShadowPriestDoTTimerFrameScaleFrame = ShadowPriestDoTTimerFrame:GetScale();
		point, relativeTo, relativePoint, xOffset, yOffset = self:GetPoint(1);
		ShadowPriestDoTTimerxPosiFrame = xOffset;
	elseif (event == "PLAYER_REGEN_ENABLED") then
		if (maxmoblist < #moblist) then
			--DP and VT don't last more than a minute so once we've been ooc for a minute, clear up the list.
			for i = 1, #moblist do
				if (moblist[i][4]-GetTime() > 60000 and moblist[i][1] ~= currentmob[1]) then
					table.remove(moblist, i);
				end
			end
		end
		isincombat = false;
	elseif (event == "PLAYER_REGEN_DISABLED") then
		isincombat = true;
	end
end

function SetCooldownOffsets()
	point, relativeTo, relativePoint, xOfs, yOfs = TEXT1:GetPoint();
	TEXT1:SetPoint(point, relativeTo, relativePoint, xOfs, CooldownOffset);
	point, relativeTo, relativePoint, xOfs, yOfs = TEXT2:GetPoint();
	TEXT2:SetPoint(point, relativeTo, relativePoint, xOfs, CooldownOffset);
	point, relativeTo, relativePoint, xOfs, yOfs = TEXT3:GetPoint();
	TEXT3:SetPoint(point, relativeTo, relativePoint, xOfs, CooldownOffset);
	--nothing for TEXT4
	point, relativeTo, relativePoint, xOfs, yOfs = TEXT5:GetPoint();
	TEXT5:SetPoint(point, relativeTo, relativePoint, xOfs, CooldownOffset);
	point, relativeTo, relativePoint, xOfs, yOfs = TEXT6:GetPoint();
	TEXT6:SetPoint(point, relativeTo, relativePoint, xOfs, CooldownOffset);
	point, relativeTo, relativePoint, xOfs, yOfs = TEXT7:GetPoint();
	TEXT7:SetPoint(point, relativeTo, relativePoint, xOfs, CooldownOffset);
	point, relativeTo, relativePoint, xOfs, yOfs = TEXT8:GetPoint();
	TEXT8:SetPoint(point, relativeTo, relativePoint, xOfs, CooldownOffset);
end

function FindCurrentMob()
	local targetguid = UnitGUID("playertarget");
	currentmob = nil;
	if (targetguid) then
		local i = 1;
		while not currentmob and i <= #moblist do
			if (moblist[i][1] == targetguid) then
				currentmob = moblist[i];
			end
			i = i + 1;
		end
	end
end

function FindOrCreateCurrentMob()
	local targetguid = UnitGUID("playertarget");
	currentmob = nil;

	if (targetguid) then
		--DEFAULT_CHAT_FRAME:AddMessage("SPDT Player Target: " .. targetguid);
		local i = 1;
		while not currentmob and i <= #moblist do
			if (moblist[i][1] == targetguid) then
				currentmob = moblist[i];
			end
			i = i + 1;
		end

		if (not currentmob) then
			currentmob = {targetguid, 0, 0, GetTime()};
			table.insert(moblist, currentmob);
			--DEFAULT_CHAT_FRAME:AddMessage("SPDT New mob: " .. currentmob[1]);
		else
			--DEFAULT_CHAT_FRAME:AddMessage("SPDT Found mob: " .. currentmob[1]);
		end
	end
end

function ClearMobList()
	for i = 1, #moblist do
		table.remove(moblist, i);
	end
	currentmob = nil;
end

function CheckCurrentTargetDeBuffs()
	local finished = false;
	local count = 0;
	local VTFound = 0;
	local VTLeft = 0;
	local VTlefttime = 0;
	local VTlasttickTime = 0;
	local VTlasttickcastTime = 0;
	local VTleftMS = 0;
	local PlagueFound = 0;
	local PlagueLeft = 0;
	local Plaguelefttime = 0;
	local WordPainFound = 0;
	local WordPainLeft = 0;
	local WordPainlefttime = 0;
	local WordPainleftMS = 0;
	local WordPainlasttickTime = 0;
	local WordPainlasttickCastTime = 0;
	local CastTime = 0;

	--PseudoGCD = castTimeVT;
	--PseudoGCD2 = castTimeVT*2;
	--PseudoGCDWarn = castTimeVT+WarningTime;
	VTlasttickTime = castTimeVT*3+WarningTime;
	VTlasttickcastTime = castTimeVT*3;
	WordPainlasttickTime = castTimeVT*2+WarningTime;
	WordPainlasttickCastTime = castTimeVT*2;

	while not finished do
		count = count+1;

		local bn,brank,bicon,bcount,bType,bduration,bexpirationTime,bisMine,bisStealable,bshouldConsolidate,bspellId =  UnitDebuff("target", count, 0);
		if not bn then
			finished = true;
		else
			--DEFAULT_CHAT_FRAME:AddMessage("testing debuff");
			if bisMine == "player" then
				--DEFAULT_CHAT_FRAME:AddMessage("ismine debuff");
				
				if bn == nameVT then 
					VTFound = 1;
					VTlefttime = floor((((bexpirationTime-GetTime())*10)+ 0.5))/10;
					if(VTlefttime <= 5.0) then				
						VTLeft = string.format("%1.1f",VTlefttime);
					else
						VTLeft = string.format("%d",VTlefttime);
					end
					VTleftMS = VTlefttime*1000;
					CastTime = castTimeVT;
					--VTleftMSSafe = VTleftMS-WarningTime;
					VTduration = bduration;
				end
				if bn == namePlague then 
					PlagueFound = 1;
					Plaguelefttime = floor((((bexpirationTime-GetTime())*10)+ 0.5))/10;		
					PlagueLeft = string.format("%1.1f",Plaguelefttime);

				end
				if bn == nameWordPain then 
					WordPainFound = 1;
					WordPainlefttime = floor((((bexpirationTime-GetTime())*10)+ 0.5))/10;
					if (WordPainlefttime <= 4.0) then
						WordPainLeft = string.format("%1.1f",WordPainlefttime);
					else
						WordPainLeft = string.format("%d",WordPainlefttime);
					end  
					WordPainleftMS = WordPainlefttime*1000;
					SWPduration = bduration;
				end
			end
		end
	end

	if (VTFound == 1) then
		if (HideIconVT == 0) then
			Texture1:Show();
			if  VTleftMS < VTlasttickTime then
				if VTleftMS < VTlasttickcastTime then
					Texture1:SetVertexColor(0.1, 0.6, 0.1);		--green
				else 
					Texture1:SetVertexColor(0.9, 0.2, 0.2);		--red
				end
			else
				if (currentmob) then
					if (currentmob[5] == true) then
						if ((GetTime() - currentmob[7]) < 15) then
							--UVLS was active during DoT application and it is < 15s active
							Texture1:SetVertexColor(0.9, 0.2, 0.2);		--red
						else
							Texture1:SetVertexColor(1.0, 1.0, 1.0);		--nothing
							currentmob[5] = false;
						end
					elseif (buffscorecurrent > (currentmob[2] + OffsetbuffscoreVT)) then
						Texture1:SetVertexColor(0.1, 0.6, 0.1);		--green
					else
						Texture1:SetVertexColor(1.0, 1.0, 1.0);		--no color				
					end
				else
					Texture1:SetVertexColor(1.0, 1.0, 1.0);			--nothing
				end	
			end
		else 
			Texture1:Hide();
		end
		
		if (HideNumberAboveVT == 0) then
			--set the color of the text above to green, when reapplication is usefull
			if (currentmob) then
				if (currentmob[5] == true) then
					if ((GetTime() - currentmob[7]) < 15) then
						--UVLS was active during DoT application and it is < 15s active
						TEXT1Above:SetVertexColor(0.9, 0.2, 0.2);		--red
					else
						TEXT1Above:SetVertexColor(1.0, 1.0, 1.0);		--nothing
						currentmob[5] = false;
					end
				elseif (buffscorecurrent > (currentmob[2] + OffsetbuffscoreVT)) then
					TEXT1Above:SetVertexColor(0.1, 0.6, 0.1);	--green
				else
			   		TEXT1Above:SetVertexColor(1.0, 0.9, 0.1);	--red
		   		end
			else
		   	TEXT1Above:SetVertexColor(1.0, 0.9, 0.1);		--yellow
			end
			TEXT1Above:Show();
		end
		
		FindCurrentMob();
		if (currentmob and (HideNumberAboveVT == 0)) then
			if (currentmob[5] == true) then
				TEXT1Above:SetText(string.format("%s", "UVLS"));
			else
				TEXT1Above:SetText(string.format("%d", currentmob[2]));
			end
		end
		
		if (HideTimerVT == 0) then
			TEXT1:SetText(VTLeft);
			TEXT1:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
			TEXT1:Show();
		else
			TEXT1:Hide();
		end
	else
		TEXT1Above:Hide();
		TEXT1:Hide();
		Texture1:Hide();
	end

	if (WordPainFound == 1) then
		if(HideIconSWP == 0) then
			Texture2:Show();
			if  WordPainleftMS < WordPainlasttickTime then
				if (WordPainleftMS < WordPainlasttickCastTime)  then
					Texture2:SetVertexColor(0.1, 0.6, 0.1);	--green
				else				
					Texture2:SetVertexColor(0.9, 0.2, 0.2);	--red
				end
			else
				if (currentmob) then
					if (currentmob[6] == true) then
						if ((GetTime() - currentmob[8]) < 18) then
							--UVLS was active during DoT application and it is < 18s active
							Texture2:SetVertexColor(0.9, 0.2, 0.2);		--red
						else
							Texture2:SetVertexColor(1.0, 1.0, 1.0);		--nothing
							currentmob[6] = false;
						end
					elseif (buffscorecurrent > (currentmob[3] + OffsetbuffscoreSWP)) then
						Texture2:SetVertexColor(0.1, 0.6, 0.1);		--green
					else
						Texture2:SetVertexColor(1.0, 1.0, 1.0);		--no color				
					end
				else
					Texture2:SetVertexColor(1.0, 1.0, 1.0);		--no color
				end
			end
		else
			Texture2:Hide();	
		end
		
		if (HideNumberAboveSWP == 0) then
			--set the color of the text above to green, when reapplication is usefull
			if (currentmob) then
				if (currentmob[6] == true) then
					if ((GetTime() - currentmob[8]) < 18) then
					--UVLS was active during DoT application and it is < 18s active
						TEXT2Above:SetVertexColor(0.9, 0.2, 0.2);		--red
					else
						TEXT2Above:SetVertexColor(1.0, 1.0, 1.0);		--nothing
						currentmob[6] = false;
					end
				elseif (buffscorecurrent > (currentmob[3] + OffsetbuffscoreSWP)) then
					TEXT2Above:SetVertexColor(0.1, 0.6, 0.1);	--green
				else
			   		TEXT2Above:SetVertexColor(1.0, 0.9, 0.1);	--red
		   		end
			else
		   	TEXT2Above:SetVertexColor(1.0, 0.9, 0.1);		--yellow
			end
			TEXT2Above:Show();
		end
	
		FindCurrentMob();
		if (currentmob and (HideNumberAboveSWP == 0)) then
			if (currentmob[6] == true) then
				TEXT2Above:SetText(string.format("%s", "UVLS"));
			else
				TEXT2Above:SetText(string.format("%d", currentmob[3]));
			end
		end
		
		if (HideTimerSWP == 0) then 
			TEXT2:SetText(WordPainLeft);
			TEXT2:SetTextColor(1.0, 1.0, 1.0);
			TEXT2:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
			TEXT2:Show();
		else
			TEXT2:Hide();
		end
	else

		TEXT2Above:Hide();
		Texture2:Hide();
		TEXT2:Hide();
	end
	
	if (PlagueFound == 1) then
		Texture3used = true;
		if (SolaceInsanity_Check() == true and HideSoD == 0) then
		--Shadow Word: Insanity Cooldown Procedure
		--Cooldown -> No Color
			Texture3:SetVertexColor(0.1, 0.6, 0.1);		--green with the correct cooldown
			Texture3:SetTexture(IconSolaceInsanity);
			Texture3:Show();
			if (HideNumberAboveSaI == 0) then
				TEXT3Above2:SetText(string.format("%s", PrevShadowOrbsCount));
				TEXT3Above2:Show();
				TEXT3Above:Hide();
			end
			if (HideTimerDP == 0) then
				TEXT3:SetText(PlagueLeft);
				TEXT3:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
				TEXT3:Show();
			else
				TEXT3:Hide();
			end
		elseif(HideDP == 0) then
			if (HideIconDP == 0) then
				Texture3:SetTexture(IconPlague);
				Texture3:SetVertexColor(1.0, 1.0, 1.0);		--no color
				Texture3:Show();
			else
				Texture3:Hide();
			end
			TEXT3Above:Hide();
			TEXT3Above2:Hide();
			if (HideTimerDP == 0) then
				TEXT3:SetText(PlagueLeft);
				TEXT3:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
				TEXT3:Show();
			else
				TEXT3:Hide();
			end
		else
			Texture3:Hide();
			TEXT3:Hide();
			TEXT3Above:Hide();
			TEXT3Above2:Hide();
		end
	else
		Texture3used = false;
		Texture3:Hide();
		TEXT3:Hide();
		TEXT3Above:Hide();
		TEXT3Above2:Hide();
	end

	return 
end

function CheckPlayerBuffs()
	local Texture6CD = 0;
	local Texture7CD = 0;
	local finished = false;
	local count = 0;
	local ShadowOrbsFound = 0;
	local ShadowOrbsStacks = 0;
	local ShadowOrbsLeft = 0;
	local EmbraceFound = 0;
	local EmbraceLeft = 0;
	local PowerInfusionFound = 0;
	local SurgeOfDarknessStacks = 0;
	local PowerInfusionLeft = 0;
	local SurgeOfDarknessFound = 0;
	local SurgeOfDarknessLeft = 0;
	local MindbenderLeft = 0;
	local DivInFound = 0;
	local DivInLeft = 0;
	local MBLeft = 0;
	local PowerInfCD = 0;
	local EmbraceCD = 0;
	local SurgeOfDarknessCD = 0;
	local MindbenderCD = 0;
	UVLS_active = false;
	Texture4:Hide();
	
	local found = false;
	local i = 0;
	local found1 = false;
	local j = 0;
	local k = 0;
	local l = 0;
	
	local PseudoGCD = castTimeVT;
	
	local SPELL_POWER_SHADOW_ORBS  = SPELL_POWER_SHADOW_ORBS;
	local NumOfOrbs = UnitPower('player', SPELL_POWER_SHADOW_ORBS);

	buffscorecurrent = 0;
	local buffscorehaste = 1;
	local buffscorehastetemp = 0;
	local base, stat, posBuff, negBuff = UnitStat("player",4);

	while not finished do
		count = count+1;
		local bn,brank,bicon,bcount,bType,bduration,bexpirationTime,bisMine,bisStealable,bshouldConsolidate,bspellId =  UnitBuff("player", count, 0);

		local modifiedint = base + buffscorecurrent;
		
		if not bn then
			finished = true;
		else
			--UVLS check for indication of 100% CritBuff
			--if (bspellId == 139133) then
			if (bspellId == 138963) then
				UVLS_active = true;
				if (Show_UVLSicon == 1) then
					Texture4:SetTexture(IconUVLS);
					Texture4:Show();
				end
			end
			if (NumOfOrbs > 0) then
				ShadowOrbsFound		= 1;
				ShadowOrbsStacks	= NumOfOrbs;
			end
			if (bn == nameEmbrace) then 
				EmbraceFound = 1;
				EmbraceLeft = string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10);		-- as formated string						
			end
			if (bn == namePowerInfusion) then
				PowerInfusionFound	= 1;
				PowerInfusionLeft = string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10); 
			end	
			if (bn == nameSurgeOfDarkness) then
				SurgeOfDarknessFound	= 1;
				SurgeOfDarknessStacks = bcount;
				SurgeOfDarknessLeft = string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10);
			end
			if (bn == nameDivIn) then
				DivInFound = 1;
				DivInLeft = string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10);
			end 
			
			-------------------------------------
			--loop the buffs in the list until we find a match.
			found = false;
			i = 1;
			while found == false and i <= #BuffList do
				local entry = BuffList[i];
				if (entry) then
					if (bn == entry[1]) then
						found = true;

						if (bcount <= 0) then
							bcount = entry[4];
						end

						if (string.lower(entry[2]) == "int") then
							buffscorecurrent = buffscorecurrent + (entry[3] * bcount);
						elseif (string.lower(entry[2]) == "mastery") then
							buffscorecurrent = buffscorecurrent + (entry[3] * bcount * MasteryWeight);
						elseif (string.lower(entry[2]) == "crit") then
							buffscorecurrent = buffscorecurrent + (entry[3] * bcount * CritWeight);
						elseif (string.lower(entry[2]) == "haste") then
							if (CalcHasteNew == 1) then
							--the more accurate haste calculation
								for k = bcount, 1, -1 do
									buffscorehastetemp = (entry[3] / 425.2);
									buffscorehastetemp = (buffscorehastetemp / 100);
									buffscorehastetemp = buffscorehastetemp + 1;
									buffscorehaste   = buffscorehaste   * buffscorehastetemp;
								end
								--DEFAULT_CHAT_FRAME:AddMessage("Hastebuff: " .. buffscorehaste);
							else
							--the old standard calculation
								buffscorecurrent = buffscorecurrent + (entry[3] * bcount * HasteWeight);
							end	
						elseif (string.lower(entry[2]) == "damage") then
							buffscorecurrent = buffscorecurrent + (entry[3] * bcount * modifiedint * DamageWeight);
						elseif (string.lower(entry[2]) == "spellpower") then
							buffscorecurrent = buffscorecurrent + (entry[3] * bcount * SpellpowerWeight);
						end
					end
				end

				i = i + 1;
			end

			found1 = false;
			j = 1;
			while found1 == false and j <= #ClassBuffList do
				local entry1 = ClassBuffList[j];
				if (entry1) then
					if (bspellId == entry1[1]) then
						found1 = true;

						if (bcount <= 0) then
							bcount = entry1[4];
						end

						if (string.lower(entry1[2]) == "int") then
							buffscorecurrent = buffscorecurrent + (entry1[3] * bcount);
						elseif (string.lower(entry1[2]) == "mastery") then
							buffscorecurrent = buffscorecurrent + (entry1[3] * bcount * MasteryWeight);
						elseif (string.lower(entry1[2]) == "crit") then
							buffscorecurrent = buffscorecurrent + (entry1[3] * bcount * CritWeight);
						elseif (string.lower(entry1[2]) == "haste") then
							if (CalcHasteNew == 1) then
								for l = bcount, 1, -1 do
									buffscorehastetemp = (entry1[3] / 425.2);
									buffscorehastetemp = (buffscorehastetemp / 100);
									buffscorehastetemp = buffscorehastetemp + 1;
									buffscorehaste   = buffscorehaste   * buffscorehastetemp;
								end
								--DEFAULT_CHAT_FRAME:AddMessage("Hastebuff 2: " .. buffscorehaste);
							else
								buffscorecurrent = buffscorecurrent + (entry1[3] * bcount * HasteWeight);
							end
						elseif (string.lower(entry1[2]) == "damage") then
							buffscorecurrent = buffscorecurrent + (entry1[3] * bcount * modifiedint * DamageWeight);
						elseif (string.lower(entry1[2]) == "spellpower") then
							buffscorecurrent = buffscorecurrent + (entry1[3] * bcount * SpellpowerWeight);
						end
					end
				end

				j = j + 1;
			end		
				
		end --one buff check finished
		
	end --finished buff loop check of all buffs

	--Has there been an active Haste buff?
	if (CalcHasteNew == 1 and buffscorehaste ~= 1) then
		--Add the HasteWeight to the haste score
		--DEFAULT_CHAT_FRAME:AddMessage("Haste Buff Score Sum: " .. buffscorehaste);
		buffscorehastetemp = (((buffscorehaste -1) *100 ) * 425.2);
		--DEFAULT_CHAT_FRAME:AddMessage("Haste Buff Score Sum after recalculation: " .. buffscorehastetemp);	
		buffscorehaste = buffscorehastetemp * HasteWeight;
		--DEFAULT_CHAT_FRAME:AddMessage("Haste Buff Score with Weight: " .. buffscorehaste);
		--Add the multiplied Hastebuffs to the buffscore
		buffscorecurrent = buffscorecurrent + buffscorehaste;
	else
		--If no Haste buff is active, don't calculate the 1 to the buffscore
	end



	-- ShadowWord:Death Icon and Display Procedure --
	if (HideSWD == 0) then
		local SWDstart, SWDduration, SWDenabled = GetSpellCooldown(WordDeathID);
		local UnitHP = ceil(UnitHealth("target") / UnitHealthMax("target") * 100);
		if  ((UnitHP <= 20) and (UnitHP > 0)) then
			if (SWDstart == 0 and SWDenabled == 1 and isincombat == true) then
				Texture5:SetTexture(IconWordDeath);
				Texture5:SetVertexColor(0.1, 0.6, 0.1);			--green
				Texture5:Show();
				Texture5used = true;
				TEXT5:Hide();
			else
				TEXT5:Hide();
				Texture5:Hide();		
				Texture5used = false;	
			end
		else				
			TEXT5:Hide();
			Texture5:Hide();
			Texture5used = false;
		end
	else
		Texture5:Hide();
		TEXT5:Hide();
		Texture5used = false;
	end	
	
	--Mindblast Icon and Cooldown Procedure
	if (Texture5used == false) then
		local MBstart, MBduration, MBenabled = GetSpellCooldown(MindBlastID);	--MB CD
		local MBLeft = MBduration - (floor((((GetTime()-MBstart)*10)+ 0.5))/10);
		if (HideMB == 0 and MBstart > 0 and MBduration > 1.5 and isincombat == true) then
			TEXT5:SetText(string.format("%1.1f", MBLeft));
			TEXT5:Show();
			TEXT5:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
			Texture5:SetVertexColor(1.0, 1.0, 1.0);		--no colour
			Texture5:SetTexture(IconMindBlast);		
			Texture5:Show();
		elseif (ShowMBOffCD == 1 and HideMB == 0 and isincombat == true) then
			TEXT5:Hide();
			Texture5:SetVertexColor(0.1, 0.6, 0.1);		--green
			Texture5:SetTexture(IconMindBlast);	
			Texture5:Show();
		else
			TEXT5:Hide();
			Texture5:Hide();
		end
	end
		
	--Shadoworbs Icon and Count Procedure
	if (Texture3used == false) then 
		if (ShadowOrbsFound == 1 and HideOrbs == 0  and isincombat == true) then
			Texture3:SetTexture(IconShadowOrbs);
			Texture3:Show();
			TEXT3Above:SetText(ShadowOrbsStacks);
			TEXT3Above:Show();
			TEXT3Above2:Hide();	
			
			if ShadowOrbsStacks == 3 then
				Texture3:SetVertexColor(0.1, 0.6, 0.1);		--green
			else
				Texture3:SetVertexColor(0.9, 0.2, 0.2);		--red
			end
			
		else 
			Texture3:Hide();
			TEXT3:Hide();	
			TEXT3Above:Hide();
			TEXT3Above2:Hide();
		end	
	end

	if (PowInf_Check() == true) then
		--PowerInfusion Icon and Cooldown Procedure	
		local PowerInfStart, PowerInfDuration, PowerInfEnabled = GetSpellCooldown(PowerInfusionID);	--PowerInfusion CD
		PowerInfCD = PowerInfDuration - (floor((((GetTime()-PowerInfStart)*10)+ 0.5))/10);
		--Cooldown -> No Color
		if (HidePInf == 0 and PowerInfStart > 0 and PowerInfDuration > 0.5 and isincombat == true) then
			if (PowerInfusionFound == 1) then
				Texture6:SetVertexColor(0.1, 0.6, 0.1);		--green with PowerInfusion Icon
				Texture6:SetTexture(IconPowerInfusion);
				Texture6:Show();
				TEXT6:SetText(PowerInfusionLeft);
				TEXT6:Show();
				TEXT6Above:Hide()
			else 
				Texture6:SetVertexColor(0.9, 0.2, 0.2);		--red with the correct cooldown
				Texture6:Show();
				Texture6CD = PowerInfCD;
				Texture6:SetTexture(IconPowerInfusion);
				TEXT6:SetText(string.format("%1.0f", Texture6CD));
				TEXT6:Show();
				TEXT6Above:Hide();
			end
		elseif (HidePInf == 0 and ShowPIOffCD == 1 and isincombat == true) then
			Texture6:SetVertexColor(1.0, 1.0, 1.0);		--no colour
			Texture6:Show();
			TEXT6Above:Hide();
			TEXT6:Hide()
		else
			Texture6:Hide();
			TEXT6:Hide();
			TEXT6Above:Hide();
		end
	end		
		
	if (DivIn_Check() == true) then
			--Cooldown -> No Color
		if (HidePInf == 0 and DivInFound == 1 and isincombat == true) then
			Texture6:SetVertexColor(0.1, 0.6, 0.1);		--green with Divine Insight Icon
			Texture6:SetTexture(IconDivIn);
			Texture6:Show();
			TEXT6:SetText(DivInLeft);
			TEXT6:Show();
			TEXT6Above:Hide()	
		else
			Texture6:Hide();
			TEXT6:Hide();
			TEXT6Above:Hide();
		end
	end
	
	
	if (FDCL_Check() == true) then
		--SurgeOfDarkness Icon Procedure
		--Cooldown -> No Color
		if (HideSoD == 0 and SurgeOfDarknessFound == 1 and isincombat == true) then
			Texture7:SetVertexColor(0.1, 0.6, 0.1);		--green with Surge of Darkness
			Texture7:SetTexture(IconSurgeOfDarkness);
			Texture7:Show();
			TEXT7:SetText(SurgeOfDarknessLeft);
			TEXT7:Show();
			TEXT7Above:SetText(SurgeOfDarknessStacks);
			TEXT7Above:Show()
		else
			Texture7:Hide();
			TEXT7:Hide();
			TEXT7Above:Hide();
		end	
	end
	
	
	if (Mindbender_Check() == true) then
		--Mindbender Icon and CD Procedure
		local MindbenderStart, MindbenderDuration, MindbenderEnabled = GetSpellCooldown(MindbenderID);	--Mindbender CD
		MindbenderCD = MindbenderDuration - (floor((((GetTime()-MindbenderStart)*10)+ 0.5))/10);
		if (HideSoD == 0 and MindbenderStart > 0 and MindbenderDuration > 0.5 and isincombat == true) then
			MindbenderLeft = string.format("%1.1f", 15.5 + (MindbenderStart - GetTime()));
			if (IsPetAttackActive() == true or MindbenderCD > 45) then
				Texture7:SetVertexColor(1.0, 1.0, 1.0);		--no colour
				Texture7:SetTexture(IconMindbender);
				Texture7:Show();
				TEXT7:SetText(MindbenderLeft);
				TEXT7:Show();
				TEXT7Above:Hide()
			elseif (MindbenderDuration >= 2) then
				Texture7:SetVertexColor(0.9, 0.2, 0.2);		--red with the correct cooldown
				Texture7:SetTexture(IconMindbender);
				Texture7:Show();
				Texture7CD = MindbenderCD;
				TEXT7:SetText(string.format("%1.0f", Texture7CD));
				TEXT7:Show();
				TEXT7Above:Hide();
			end
		else
			Texture7:Hide();
			TEXT7:Hide();
			TEXT7Above:Hide();
		end
	end			


	--Vampiric Embrace Icon and Cooldown Procedure
	local EmbraceStart, EmbraceDuration, EmbraceEnabled = GetSpellCooldown(EmbraceID);  --VampiricEmbrace  CD
	EmbraceCD = EmbraceDuration - (floor((((GetTime()-EmbraceStart)*10)+ 0.5))/10); 
	if (HideVEmbrace == 0 and EmbraceStart > 0 and EmbraceDuration > 0.5 and isincombat == true) then
		if (EmbraceFound == 1 ) then
			Texture8:SetVertexColor(0.1, 0.6, 0.1);		--green
			Texture8:Show();
			TEXT8:SetText(EmbraceLeft);
			TEXT8:Show();
			TEXT8Above:Hide()
		else
			Texture8:SetVertexColor(0.9, 0.2, 0.2);		--red
			Texture8:Show();
			TEXT8:SetText(string.format("%1.0f", EmbraceCD));
			TEXT8:Show();
			TEXT8Above:Hide();
		end
	elseif (ShowVEOffCD == 1 and HideVEmbrace == 0 and isincombat == true) then
		Texture8:SetVertexColor(1.0, 1.0, 1.0);		--no colour
		Texture8:Show();
		TEXT8Above:Hide();
		TEXT8:Hide()
	else
		Texture8:Hide();
		TEXT8:Hide();
		TEXT8Above:Hide();
	end	
return 
end

-- check for talent Solace and Insanity is learned
function SolaceInsanity_Check()
	-- SW:Insanity -- 
	local name, texture, tier, column, selected = GetTalentInfo(9)	
	if (selected == true) then
		return true
	else
		return false
	end
end

-- check for talent Mindbender is learned
function Mindbender_Check()
	-- Mindbender -- 
	local name, texture, tier, column, selected = GetTalentInfo(8);
	if (selected == true) then
		return true;
	else
		return false;
	end
end

-- check for talent From Darkness Comes Light is learned
function FDCL_Check()
	-- FDCL --
	local name, texture, tier, column, selected = GetTalentInfo(7);
	if (selected == true) then
		return true;
	else
		return false;
	end	
end

-- check for talent Power Infusion is learned
function PowInf_Check()
	-- Power Infusion --
	local name, texture, tier, column, selected = GetTalentInfo(14);
	if (selected == true) then
		return true;
	else
		return false;
	end	
end

-- check for talent Divine Insight is learned
function DivIn_Check()
	-- Divine Insight --
	local name, texture, tier, column, selected = GetTalentInfo(15);
	if (selected == true) then
		return true;
	else
		return false;
	end	
end


SLASH_SHADOWPRIESTDOTTIMER1, SLASH_SHADOWPRIESTDOTTIMER2 = '/spdt', '/ShadowPriestDoTTimer';

local function SLASH_SHADOWPRIESTDOTTIMERhandler(msg, editbox)
	if msg == 'show' then
		ShadowPriestDoTTimerFrame:Show();
	elseif  msg == 'hide' then
		ShadowPriestDoTTimerFrame:Hide();
	elseif  msg == 'reset' then
		ShadowPriestDoTTimerFrame:Hide();
		ShadowPriestDoTTimerFrame:Show();
		ClearMobList();
	elseif  msg == 'clear' then
		ClearMobList();
	elseif  msg == 'noconfigmode' then
		if (isincombat == false) then	
			ShadowPriestDoTTimerFrame:EnableMouse(false);
			ShadowPriestDoTTimerFrame:SetBackdrop(nil);
			SetCooldownOffsets();
		else
			print("Please wait for beeing Out of Combat, to stop moving SPDT")	
		end
	elseif  msg == 'configmode' then
		if(isincombat == false) then
			ShadowPriestDoTTimerFrame:EnableMouse(true);
			ShadowPriestDoTTimerFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile= "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 4, tile = false, tileSize =16, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		else
			print("Please wait for beeing Out of Combat, to move SPDT")
		end
	elseif  msg == 'options' then
		InterfaceOptionsFrame_OpenToCategory("Shadow Priest DoT Timer");
	elseif  msg == 'scale1' then
		ShadowPriestDoTTimerScaleFrame = 0.5
		ShadowPriestDoTTimerFrame:SetScale(ShadowPriestDoTTimerScaleFrame);
	elseif  msg == 'scale2' then
		ShadowPriestDoTTimerScaleFrame = 0.6
		ShadowPriestDoTTimerFrame:SetScale(ShadowPriestDoTTimerScaleFrame);
	elseif  msg == 'scale3' then
		ShadowPriestDoTTimerScaleFrame = 0.7
		ShadowPriestDoTTimerFrame:SetScale(ShadowPriestDoTTimerScaleFrame);
	elseif  msg == 'scale4' then
		ShadowPriestDoTTimerScaleFrame = 0.8
		ShadowPriestDoTTimerFrame:SetScale(ShadowPriestDoTTimerScaleFrame);
	elseif  msg == 'scale5' then
		ShadowPriestDoTTimerScaleFrame = 0.9
		ShadowPriestDoTTimerFrame:SetScale(ShadowPriestDoTTimerScaleFrame);
	elseif  msg == 'scale6' then
		ShadowPriestDoTTimerScaleFrame = 1.0
		ShadowPriestDoTTimerFrame:SetScale(ShadowPriestDoTTimerScaleFrame);
	else
		print("Syntax: /spdt (show | hide | reset | configmode | noconfigmode | options | clearmoblist )");
		print("Syntax: /spdt (scale1 | scale2 | scale3 | scale4 | scale5 | scale6)");
	end
end

SlashCmdList["SHADOWPRIESTDOTTIMER"] = SLASH_SHADOWPRIESTDOTTIMERhandler;







